#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2zero4search.py">
#<abstract4xi abstract = "shoots to direction zero"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2zero4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2zero4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2zero4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4zero

global count2ack4zero
global count2nack4zero
global count2found4zero
global count2short4zero

global current2series4zero
global candidate2series4zero

global fileobject4zero  

global keys2profile4zero
global key2profile4zero

global left2find4zero

global maxsize2ack4zero    
global maxsize2file4zero 
global max2short4zero
global meansize2ack4zero
global minsize2ack4zero

global zero2analyse4search

global profile2fetch4zero

global right2find4zero

global sumsize2ack4zero    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4zero = VersionKB4Xi['base2shoot4zero']             # base internet address, None=local url

count2ack4zero   = 0
count2nack4zero  = 0
count2found4zero = 0
count2short4zero = 0

left2find4zero = '('

max2short4zero = VersionKB4Xi['max2short4zero']
maxsize2file4zero = VersionKB4Xi['maxsize2file4zero']
maxsize2ack4zero  = 0
meansize2ack4zero = 0
minsize2ack4zero  = 0

current2series4zero = "current2series4zero5dummy"
candidate2series4zero  = "candidate2series4zero5dummy"


zero2analyse4search  = VersionKB4Xi['zero2analyse4search']

profile2fetch4zero = {}
profile2fetch4zero [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4zero [2] = '.jpg'
keys2profile4zero = profile2fetch4zero.keys()

right2find4zero = ')'

sumsize2ack4zero  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4zero" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4zero(target2explore4zero):
    global count2ack4zero
    global count2nack4zero
    global count2found4zero
    global count2short4zero
    
    global fileobject4zero 
       
    global keys2profile4zero
    global key2profile4zero
    
    global left2find4zero

    global max2short4zero    
    global maxsize2file4zero     
    global maxsize2ack4zero    
    global meansize2ack4zero
    global minsize2ack4zero
  
    global candidate2series4zero
    global current2series4zero
    
    
    global profile2fetch4zero                         # extension for files
    
    global right2find4zero
    
    global sumsize2ack4zero    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4zero = count2found4zero + 1
    ack2debug4zero = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4zero)
    
    ack2profile = False
    for key2profile4zero in keys2profile4zero:
        if name2target[1] == profile2fetch4zero[key2profile4zero]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2ZERO4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4zero
        if ack2debug4zero is True:
            print("(STEP 0A/33) OF SHOOT2ZERO4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2ZERO4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4zero:
            count2nack4zero = count2nack4zero + 1
        else:
            count2ack4zero = count2ack4zero + 1
            sumsize2ack4zero = sumsize2ack4zero + size2file
            if size2file > maxsize2ack4zero:
                maxsize2ack4zero = size2file
            if ((size2file < minsize2ack4zero) or (minsize2ack4zero == 0)):
                print("(STEP 0B/33) OF SHOOT2ZERO4SEARCH - USING MINSIZE2ACK4ZERO: ", minsize2ack4zero, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4ZERO:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2zero//d\zerofly29july2012\zerofly29july2012 (1).JPG 
                # USING MINSIZE2ACK4ZERO:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2zero//d\zerofly29july2012\zerofly29july2012 (2).JPG
                minsize2ack4zero = size2file
                print("(STEP 0C/33) OF SHOOT2ZERO4SEARCH - SET MINSIZE2ACK4ZERO TO: ", minsize2ack4zero, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4ZERO TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2zero//d\zerofly29july2012\zerofly29july2012 (1).JPG
                # SET MINSIZE2ACK4ZERO TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2zero//d\zerofly29july2012\zerofly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4zero = target2explore4zero
            if ack2debug4zero is True:print("(STEP 1A/33) OF SHOOT2ZERO4SEARCH - URL2WEB4ZERO: ", url2web4zero) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4zero,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4zero = url2web4zero[0:index2edit] + string2use + url2web4zero[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4zero)
            shortname2web4zero = name2web[0]
            if ack2debug4zero is True:
                print("(STEP 1B/33) OF SHOOT2ZERO4SEARCH - SHORTNAME2WEB4ZERO: ", shortname2web4zero)
                # 
            
            string2find4zero = '/'
            ackall2found4zero = False           
            while 1:
                if ackall2found4zero is True:
                    break
                else:
                    index2find4zero=str.find(shortname2web4zero,string2find4zero)   
                    if index2find4zero == -1:
                        ackall2found4zero = True
                    else:
                        shortname2web4zero = shortname2web4zero[index2find4zero+1:]
                        
            if ack2debug4zero is True:            
                print("(STEP 1C/33) OF SHOOT2ZERO4SEARCH - SHORTNAME2WEB4ZERO: ", shortname2web4zero)
                # 
                
            ackall2found4zero = False 
            while 1:
                if ackall2found4zero is True:
                    break
                else:
                    index2left4zero=str.find(shortname2web4zero,left2find4zero)
                    if index2left4zero == -1:
                        current2series4zero = shortname2web4zero
                        if ack2debug4zero is True:
                            print("(STEP 2A/33) OF SHOOT2ZERO4SEARCH - CURRENT2SERIES4ZERO: ", current2series4zero) 
                            # 
                        ackall2found4zero = True
                         
                    else:
                        index2right4zero=str.find(shortname2web4zero,right2find4zero)
                        if index2right4zero == -1:
                            ackall2found4zero = True 
                        else:
                            candidate2series4zero = shortname2web4zero[0:index2left4zero]
                            
                            index3find4zero=str.find(shortname2web4zero,current2series4zero)
                            if index3find4zero == -1:
                                
                                current2series4zero = candidate2series4zero
                                if ack2debug4zero is True:
                                    print("(STEP 2B/33) OF SHOOT2ZERO4SEARCH - CURRENT2SERIES4ZERO: ", current2series4zero) 
                                    # 
                                
                                count2short4zero = 0
                                fileobject4zero.write('<br />' + '\n')
                            else:
                                shortname2web4zero = shortname2web4zero[index2left4zero:index2right4zero+1]
                                if ack2debug4zero is True:
                                    print("(STEP 2C/33) OF SHOOT2ZERO4SEARCH - SHORTNAME2WEB4ZERO: ", shortname2web4zero)
                                    # 
                                
                                count2short4zero = count2short4zero + 1
                                if count2short4zero >= max2short4zero:
                                    count2short4zero = 0
                                else:
                                    pass       
                            ackall2found4zero = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4zero is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4zero.write('<br /><b>&raquo;</b><a href="' + url2web4zero + '" target="_blank">' + shortname2web4zero + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4zero = zero2analyse4search
                if ack2debug4zero is True:
                    print("(STEP 3A/33) OF SHOOT2ZERO4SEARCH - BASE2LOCAL4ZERO: ", base2local4zero)
                    #              
                ack2localtries4zero = False                   
                while 1:
                    if ack2localtries4zero is True:
                        break
                    else:
                        index2find4zero=str.find(url2web4zero,base2local4zero)            
                        # 
                        #  
                        if index2find4zero == -1:
                            ack2localtries4zero = True
                        else:
                            if ack2debug4zero is True:
                                print("(STEP 3B/33) OF SHOOT2ZERO4SEARCH - BASE2BUILD4ZERO: ", base2build4zero)
                                # 
                            url2web4zero = base2build4zero + url2web4zero[len(base2local4zero):]
                            if ack2debug4zero is True:
                                print("(STEP 3C/33) OF SHOOT2ZERO4SEARCH - URL2WEB4ZERO: ", url2web4zero)
                                # 
                            
                            if count2short4zero < 1: 
                                fileobject4zero.write('<br /><b>&raquo;</b><a href="' + url2web4zero + '" target="_blank">' + shortname2web4zero + '</a>' + '\n')
                            else:
                                fileobject4zero.write('<b>&raquo;</b><a href="' + url2web4zero + '" target="_blank">' + shortname2web4zero + '</a>\n')                            
                            ack2localtries4zero = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2ZERO4SEARCH FAILED, FILEOBJECT4ZERO-WRITE-FAILED: ", str(fileobject4zero), time4xi())
      
    else:
        
        count2nack4zero = count2nack4zero + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2zero4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2zero4search(queue2zero = None, consumer_channel2zero = None, publisher_channel2zero = None, path2zero = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4zero
    global count2nack4zero
    global count2found4zero
    
    global fileobject4zero    
    
    global maxsize2ack4zero    
    global meansize2ack4zero
    global minsize2ack4zero
    global sumsize2ack4zero    
    
    global maxsize2file4zero 
    
    global profile2fetch4zero                         # extension for files
    global keys2profile4zero
    global key2profile4zero

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2ZERO4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2ZERO4SEARCH -  QUEUE2ZERO: ", queue2zero)      
    # QUEUE2ZERO:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2ZERO4SEARCH -  CONSUMER_CHANNEL2ZERO: ", consumer_channel2zero)
    # CONSUMER_CHANNEL2ZERO:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2ZERO4SEARCH -  PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero)          
    # PUBLISHER_CHANNEL2ZERO:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2zero is None) or (consumer_channel2zero is None) or (publisher_channel2zero is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2ZERO4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2ZERO4SEARCH - QUEUE2ZERO: ", queue2zero)
        print("(STEP 1C/33) OF SHOOT2ZERO4SEARCH - CONSUMER_CHANNEL2ZERO: ", consumer_channel2zero) 
        print("(STEP 1D/33) OF SHOOT2ZERO4SEARCH - PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero)
        print("(STEP 1E/33) OF SHOOT2ZERO4SEARCH - PATH2ZERO: ", path2zero)     
        
        return
 
    if (not (queue2zero is None) and not(consumer_channel2zero is None) and not(publisher_channel2zero is None) and (path2zero is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2ZERO4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2ZERO4SEARCH - QUEUE2ZERO: ", queue2zero)
        print("(STEP 2C/33) OF SHOOT2ZERO4SEARCH - CONSUMER_CHANNEL2ZERO: ", consumer_channel2zero) 
        print("(STEP 2D/33) OF SHOOT2ZERO4SEARCH - PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero)
        print("(STEP 2E/33) OF SHOOT2ZERO4SEARCH - PATH2ZERO: ", path2zero)     
        return           

    if (not (queue2zero is None) and not(consumer_channel2zero is None) and not(publisher_channel2zero is None) and not(path2zero is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2ZERO4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2ZERO4SEARCH - QUEUE2ZERO: ", queue2zero)
        # QUEUE2ZERO:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2ZERO4SEARCH - CONSUMER_CHANNEL2ZERO: ", consumer_channel2zero)
        # CONSUMER_CHANNEL2ZERO:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2ZERO4SEARCH - PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero)
        # PUBLISHER_CHANNEL2ZERO:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2ZERO4SEARCH - PATH2ZERO: ", path2zero)
        # PATH2ZERO:  F://temp//yophotos//test2zero//
       
        print("(STEP 4A/33) OF SHOOT2ZERO4SEARCH - STARTING TO WALK PATH2ZERO: ", path2zero)   
        # STARTING TO WALK PATH2ZERO:  F://temp//yophotos//test2zero//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4zero = None
        try:
            name2index4zero = "index2xxxxxxxx4yo.html"
            path2index4zero = path2zero + name2index4zero
            print("(Step 4B/33) OF SHOOT2ZERO4SEARCH - SET PATH2INDEX4ZERO TO: ", path2index4zero)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2ZERO4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4ZERO: ", path2index4zero)          
            #                    
        fileobject4zero = None
        try:
            fileobject4zero = open(path2index4zero,'w')
            print("(Step 4C/33) OF SHOOT2ZERO4SEARCH - OPENED OUTPUT: ", fileobject4zero)
            # SHOOT2ZERO4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2zero//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2ZERO4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4zero)         
            # 
        try:                
            fileobject4zero.write('<html>\n')
            
            fileobject4zero.write('<style type="text/css" media="all">\n')
            fileobject4zero.write(' @import "http://www.yourzeroxi.org/css/halongbay.css";\n')
            fileobject4zero.write('</style> \n')
            fileobject4zero.write('<p>\n')
            fileobject4zero.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4zero.write('<br /><a id="000">yourzero<b>&Xi;</b> @Content</a>\n')
            fileobject4zero.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4zero.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2ZERO4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4zero)         
            #      
        
        
        KB2name4zero = {}
        key2name4zero = 0
                 
        for file2walk in DirectoryWalker(path2zero):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4zero [key2name4zero] = file2walk
                    print ("KB2NAME4ZERO[", key2name4zero, "]: ", KB2name4zero [key2name4zero])
                    # 
                    
                    key2name4zero = key2name4zero + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2ZERO4SEARCH - FAILED UPDATING KB2NAME4ZERO WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4zero(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4zero.write('<br /> \n')
            fileobject4zero.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4zero.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4zero.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4zero.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4zero.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4zero.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4zero.write('</p>\n')
            # 
            fileobject4zero.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2ZERO4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4zero)         
            #            
        try:    
            fileobject4zero.close()
            print("(Step 4C/33) OF SHOOT2ZERO4SEARCH - CLOSED OUTPUT: ", fileobject4zero)         
            # SHOOT2ZERO4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2zero//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2ZERO4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4zero)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2ZERO4SEARCH - STARTING TO ANALYSE KB2NAME4ZERO: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4ZERO:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4zero  = {}
        AlphaKB4zero['a'] = {}
        AlphaKB4zero['b'] = {}
        AlphaKB4zero['c'] = {}
        AlphaKB4zero['d'] = {}
        AlphaKB4zero['e'] = {}
        AlphaKB4zero['f'] = {}
        AlphaKB4zero['g'] = {}
        AlphaKB4zero['h'] = {}
        AlphaKB4zero['i'] = {}
        AlphaKB4zero['j'] = {}
        AlphaKB4zero['k'] = {}
        AlphaKB4zero['l'] = {}
        AlphaKB4zero['m'] = {}
        AlphaKB4zero['n'] = {}
        AlphaKB4zero['o'] = {}
        AlphaKB4zero['p'] = {}
        AlphaKB4zero['q'] = {}
        AlphaKB4zero['r'] = {}
        AlphaKB4zero['s'] = {}
        AlphaKB4zero['t'] = {}
        AlphaKB4zero['u'] = {}
        AlphaKB4zero['v'] = {}
        AlphaKB4zero['w'] = {}
        AlphaKB4zero['x'] = {}
        AlphaKB4zero['y'] = {}
        AlphaKB4zero['z'] = {} 
        keys2AlphaKB4zero = AlphaKB4zero.keys()
        key2AlphaKB4zero  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4zero = len(path2zero)
        # 
        
        keys2name4zero = KB2name4zero.keys()
                
        for key2name4zero in sorted(keys2name4zero):
            # 
            name2optimize4zero = KB2name4zero[key2name4zero]
            # 
            shortcut2level4zero = name2optimize4zero[len2cut4zero:]
            # 
            len2shortcut4zero = len(shortcut2level4zero)
            if len2shortcut4zero == 1:
                try:
                    # LEVEL ZERO CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4zero in keys2AlphaKB4zero:
                        KB2level1[key2level1] = shortcut2level4zero
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2ZERO4SEARCH ** WARNING - SHORTCUT2LEVEL4ZERO: ", shortcut2level4zero, " NOT IN KEYS2ALPHAKB4ZERO: ", keys2AlphaKB4zero)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2ZERO4SEARCH *** FAILED - SHORTCUT2LEVEL4ZERO: ", shortcut2level4zero)      
            else:
                try:
                    
                    string2search4zero = '\\'
                    shortcut2level4zero = shortcut2level4zero[2:]
                    
                    index2level4zero=str.find(shortcut2level4zero,string2search4zero)
                    if index2level4zero == -1:
                         
                        KB2level2[key2level2] = shortcut2level4zero
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4zero = shortcut2level4zero[index2level4zero+1:]
                        index2level4zero=str.find(shortcut2level4zero,string2search4zero)
                        if index2level4zero == -1:
                            KB2level3[key2level3] = shortcut2level4zero
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4zero = shortcut2level4zero[index2level4zero+1:]
                            index2level4zero=str.find(shortcut2level4zero,string2search4zero)
                            if index2level4zero == -1:
                                KB2level4[key2level4] = shortcut2level4zero
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4zero = shortcut2level4zero[index2level4zero+1:]
                                index2level4zero=str.find(shortcut2level4zero,string2search4zero)
                                if index2level4zero == -1:
                                    KB2level5[key2level5] = shortcut2level4zero
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4zero = shortcut2level4zero[index2level4zero+1:]
                                    index2level4zero=str.find(shortcut2level4zero,string2search4zero)
                                    if index2level4zero == -1:
                                        KB2level6[key2level6] = shortcut2level4zero
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4zero = shortcut2level4zero[index2level4zero+1:]
                                        index2level4zero=str.find(shortcut2level4zero,string2search4zero)
                                        if index2level4zero == -1:
                                            KB2level7[key2level7] = shortcut2level4zero
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4zero = shortcut2level4zero[index2level4zero+1:]
                                            index2level4zero=str.find(shortcut2level4zero,string2search4zero)
                                            if index2level4zero == -1:
                                                KB2level8[key2level8] = shortcut2level4zero
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2ZERO4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4ZERO: ", shortcut2level4zero)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2ZERO4SEARCH *** FAILED - SHORTCUT2LEVEL4ZERO: ", shortcut2level4zero)   
        
        print ("(Step 6A/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # zerofly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2ZERO4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2ZERO4SEARCH - COUNT2ACK4ZERO; ", count2ack4zero)
            # COUNT2ACK4ZERO;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2ZERO4SEARCH - COUNT2NACK4ZERO; ", count2nack4zero)
            # COUNT2NACK4ZERO;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2ZERO4SEARCH - COUNT2FOUND4ZERO: ", count2found4zero)
            # COUNT2FOUND4ZERO:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2ZERO4SEARCH - FOUND MAX SIZE: ", maxsize2ack4zero)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2ZERO4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4zero)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4zero == 0:
                meansize2ack4zero = 0
                print ("(Step 7G1/33) OF SHOOT2ZERO4SEARCH - MEAN SIZE SET: ", meansize2ack4zero)
                #  
            else:       
                meansize2ack4zero = int(sumsize2ack4zero / count2ack4zero)
                print ("(Step 7G2/33) OF SHOOT2ZERO4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4zero, ", WHERE SUMSIZE2ACK4ZERO: ", sumsize2ack4zero, " COUNT2ACK4ZERO: ", count2ack4zero)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4ZERO:  10944512  COUNT2ACK4ZERO:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2ZERO4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4zero < maxsize2file4zero:
                print ("(Step 7H/33) OF SHOOT2ZERO4SEARCH - MIN SIZE MET: ", minsize2ack4zero)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2ZERO4SEARCH ** MIN DEFINED: ", minsize2ack4zero, " EQUALS TO MAXSIZE2FILE4ZERO: ", maxsize2file4zero)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2ZERO4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2ZERO4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2ZERO4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2ZERO4SEARCH - QUEUE2ZERO: ", queue2zero)
        print("(STEP 7Z3/33) OF SHOOT2ZERO4SEARCH - CONSUMER_CHANNEL2ZERO: ", consumer_channel2zero) 
        print("(STEP 7Z4/33) OF SHOOT2ZERO4SEARCH - PUBLISHER_CHANNEL2ZERO: ", publisher_channel2zero)
        print("(STEP 7Z5/33) OF SHOOT2ZERO4SEARCH - PATH2ZERO: ", path2zero)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.zeroxi.com; www.yourzeroxi.com; www.yourzeroxi.org; www.zero2xi.com/; www.zero4xi.com/; www.zero8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2zero4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
